## wordgrinder 0.4.1

=== Makefile ===
# © 2007-2013 David Given.
# WordGrinder is licensed under the MIT open source license. See the COPYING
# file in this distribution for the full text.

hide = @

PREFIX = $(HOME)
CC = gcc
WINCC = mingw32-gcc.exe
WINDRES = windres.exe
MAKENSIS = makensis

VERSION := 0.4.1
FILEFORMAT := 3
DATE := 14 April 2013

override CFLAGS += \
	-DVERSION='"$(VERSION)"' \
	-DFILEFORMAT=$(FILEFORMAT) \
	-DPREFIX='"$(HOME)"' \
	-Isrc/c \
	-Isrc/c/minizip \
	-Wall \
	-ffunction-sections \
	-fdata-sections \
	--std=c99

override LDFLAGS += \

WININSTALLER := bin/WordGrinder\ $(VERSION)\ setup.exe

all: unix

unix: \
	bin/wordgrinder \
	bin/wordgrinder-debug \
	bin/wordgrinder-static
.PHONY: unix
	
windows: \
	bin/wordgrinder.exe \
	bin/wordgrinder-debug.exe \
	$(WININSTALLER)
.PHONY: windows

wininstaller: $(WININSTALLER)
.PHONY: wininstaller

install: bin/wordgrinder bin/wordgrinder.1
	@echo INSTALL
	$(hide)install -D -m 755 bin/wordgrinder   $(PREFIX)/bin/wordgrinder
	$(hide)install -D -m 644 bin/wordgrinder.1 $(PREFIX)/share/man/man1/wordgrinder.1
	$(hide)install -D -m 644 README.wg         $(PREFIX)/share/doc/wordgrinder/README.wg
	
# --- Builds the script blob ------------------------------------------------

LUASCRIPTS := \
	src/lua/_prologue.lua \
	src/lua/xml.lua \
	src/lua/utils.lua \
	src/lua/events.lua \
	src/lua/redraw.lua \
	src/lua/document.lua \
	src/lua/forms.lua \
	src/lua/ui.lua \
	src/lua/browser.lua \
	src/lua/html.lua \
	src/lua/margin.lua \
	src/lua/fileio.lua \
	src/lua/export.lua \
	src/lua/export/text.lua \
	src/lua/export/html.lua \
	src/lua/export/latex.lua \
	src/lua/export/troff.lua \
	src/lua/export/opendocument.lua \
	src/lua/import.lua \
	src/lua/import/html.lua \
	src/lua/import/text.lua \
	src/lua/import/opendocument.lua \
	src/lua/navigate.lua \
	src/lua/addons/goto.lua \
	src/lua/addons/autosave.lua \
	src/lua/addons/docsetman.lua \
	src/lua/addons/scrapbook.lua \
	src/lua/menu.lua \
	src/lua/cli.lua \
	src/lua/main.lua

.obj/luascripts.c: $(LUASCRIPTS)
	@echo SCRIPTS
	@mkdir -p .obj
	@lua tools/multibin2c.lua script_table $^ > $@
	
clean::
	@echo CLEAN .obj/luascripts.c
	@rm -f .obj/luascripts.c
	
# --- Builds a single C file ------------------------------------------------

define cfile

$(objdir)/$(1:.c=.o): $1 Makefile
	@echo CC $$@
	@mkdir -p $$(dir $$@)
	$(hide)$(cc) $(CFLAGS) $(cflags) $(INCLUDES) -c -o $$@ $1

DEPENDS += $(objdir)/$(1:.c=.d)
objs += $(objdir)/$(1:.c=.o)

endef

# --- Builds a single RC file -----------------------------------------------

define rcfile

$(objdir)/$(1:.rc=.o): $1 Makefile
	@echo WINDRES $$@
	@mkdir -p $$(dir $$@)
	$(hide)$(WINDRES) $1 $$@

objs += $(objdir)/$(1:.rc=.o)

endef

# --- Links WordGrinder -----------------------------------------------------

define build-wordgrinder

$(exe): $(objs) Makefile
	@echo LINK $$@
	@mkdir -p $$(dir $$@)
	$(hide)$(cc) $(CFLAGS) $(cflags) $(LDFLAGS) -o $$@ $(objs) $(ldflags) 

clean::
	@echo CLEAN $(exe)
	@rm -f $(exe) $(objs)
	
endef

# --- Builds the WordGrinder core code --------------------------------------

define build-wordgrinder-core

$(call cfile, src/c/utils.c)
$(call cfile, src/c/zip.c)
$(call cfile, src/c/main.c)
$(call cfile, src/c/lua.c)
$(call cfile, src/c/word.c)
$(call cfile, src/c/screen.c)
$(call cfile, .obj/luascripts.c)

endef

# --- Builds the LFS library ------------------------------------------------

define build-wordgrinder-lfs

$(call cfile, src/c/lfs/lfs.c)

endef

# --- Builds the minizip library --------------------------------------------

define build-wordgrinder-minizip

$(call cfile, src/c/minizip/ioapi.c)
$(call cfile, src/c/minizip/zip.c)
$(call cfile, src/c/minizip/unzip.c)

endef

# --- Builds emulation routines ---------------------------------------------

define build-wordgrinder-emu

$(call cfile, src/c/emu/wcwidth.c)

endef

# --- Builds the ncurses front end ------------------------------------------

define build-wordgrinder-ncurses

$(call cfile, src/c/arch/unix/cursesw/dpy.c)

endef

# --- Builds the Windows front end ------------------------------------------

define build-wordgrinder-windows

$(call cfile, src/c/arch/win32/gdi/dpy.c)
$(call cfile, src/c/arch/win32/gdi/glyphcache.c)
$(call cfile, src/c/arch/win32/gdi/realmain.c)
$(call rcfile, src/c/arch/win32/wordgrinder.rc)

endef

# --- Unix ------------------------------------------------------------------

cc := gcc
INCLUDES := -I/usr/include/lua5.2

UNIXCFLAGS := \
	-D_XOPEN_SOURCE_EXTENDED \
	-D_XOPEN_SOURCE \
	-D_GNU_SOURCE \
	-I/usr/include/ncursesw
	
ldflags := \
	-lncursesw \
	-llua5.2 \
	-lz

cflags := $(UNIXCFLAGS) -Os -DNDEBUG
objdir := .obj/release
exe := bin/wordgrinder
objs :=
$(eval $(build-wordgrinder-core))
$(eval $(build-wordgrinder-ncurses))
$(eval $(build-wordgrinder-minizip))
$(eval $(build-wordgrinder))

cflags := $(UNIXCFLAGS) -g
objdir := .obj/debug
exe := bin/wordgrinder-debug
objs :=
$(eval $(build-wordgrinder-core))
$(eval $(build-wordgrinder-ncurses))
$(eval $(build-wordgrinder-minizip))
$(eval $(build-wordgrinder))

cflags := $(UNIXCFLAGS) -g -DEMULATED_WCWIDTH -DBUILTIN_LFS
objdir := .obj/debug-static
exe := bin/wordgrinder-static
objs :=
$(eval $(build-wordgrinder-core))
$(eval $(build-wordgrinder-ncurses))
$(eval $(build-wordgrinder-minizip))
$(eval $(build-wordgrinder-lfs))
$(eval $(build-wordgrinder-emu))
$(eval $(build-wordgrinder))


bin/wordgrinder.1: wordgrinder.man
	@echo MANPAGE
	$(hide)sed -e 's/@@@DATE@@@/$(DATE)/g; s/@@@VERSION@@@/$(VERSION)/g' $< > $@
	
# --- Windows ---------------------------------------------------------------

cc := $(WINCC)

WINDOWSCFLAGS := \
	-DEMULATED_WCWIDTH \
	-DBUILTIN_LFS \
	-DWIN32 \
	-DWINVER=0x0501 \
	-Dmain=appMain \
	-mwindows
	
ldflags := \
	-static \
	-llua \
	-lz

cflags := $(WINDOWSCFLAGS) -Os -DNDEBUG
objdir := .obj/win32-release
exe := bin/wordgrinder.exe
objs :=
$(eval $(build-wordgrinder-core))
$(eval $(build-wordgrinder-minizip))
$(eval $(build-wordgrinder-lfs))
$(eval $(build-wordgrinder-emu))
$(eval $(build-wordgrinder-windows))
$(eval $(build-wordgrinder))


cflags := $(WINDOWSCFLAGS) -g
objdir := .obj/win32-debug
exe := bin/wordgrinder-debug.exe
objs :=
$(eval $(build-wordgrinder-core))
$(eval $(build-wordgrinder-minizip))
$(eval $(build-wordgrinder-lfs))
$(eval $(build-wordgrinder-emu))
$(eval $(build-wordgrinder-windows))
$(eval $(build-wordgrinder))

src/c/arch/win32/wordgrinder.rc: src/c/arch/win32/icon.ico


$(WININSTALLER): extras/windows-installer.nsi bin/wordgrinder.exe
	@echo INSTALLER
	@mkdir -p bin # $(dir) doesn't work with spaces
	$(hide)$(MAKENSIS) -v2 -nocd -dVERSION=$(VERSION) -dOUTFILE=$(WININSTALLER) $<

clean::
	@echo CLEAN $(WININSTALLER)
	@rm -f $(WININSTALLER)
	
# --- Final setup -----------------------------------------------------------

-include $(DEPENDS)

## wordgrinder 0.5.1

=== Makefile ===
--- 
+++ 
@@ -10,9 +10,15 @@
 WINDRES = windres.exe
 MAKENSIS = makensis
 
-VERSION := 0.4.1
-FILEFORMAT := 3
-DATE := 14 April 2013
+ifneq ($(findstring Windows,$(OS)),)
+OS = windows
+else
+OS = unix
+endif
+
+VERSION := 0.5.1
+FILEFORMAT := 4
+DATE := $(shell date +'%-d %B %Y')
 
 override CFLAGS += \
 	-DVERSION='"$(VERSION)"' \
@@ -23,7 +29,7 @@
 	-Wall \
 	-ffunction-sections \
 	-fdata-sections \
-	--std=c99
+	--std=gnu99
 
 override LDFLAGS += \
 
@@ -82,6 +88,8 @@
 	src/lua/addons/autosave.lua \
 	src/lua/addons/docsetman.lua \
 	src/lua/addons/scrapbook.lua \
+	src/lua/addons/pagecount.lua \
+	src/lua/addons/widescreen.lua \
 	src/lua/menu.lua \
 	src/lua/cli.lua \
 	src/lua/main.lua
@@ -103,6 +111,12 @@
 	@echo CC $$@
 	@mkdir -p $$(dir $$@)
 	$(hide)$(cc) $(CFLAGS) $(cflags) $(INCLUDES) -c -o $$@ $1
+
+$(objdir)/$(1:.c=.d): $1 Makefile
+	@echo DEPEND $$@
+	@mkdir -p $$(dir $$@)
+	$(hide)$(cc) $(CFLAGS) $(cflags) $(INCLUDES) \
+		-MP -MM -MT $(objdir)/$(1:.c=.o) -MF $$@ $1
 
 DEPENDS += $(objdir)/$(1:.c=.d)
 objs += $(objdir)/$(1:.c=.o)
@@ -194,9 +208,14 @@
 $(call cfile, src/c/arch/win32/gdi/realmain.c)
 $(call rcfile, src/c/arch/win32/wordgrinder.rc)
 
+src/c/arch/win32/wordgrinder.rc: \
+	src/c/arch/win32/manifest.xml
+
 endef
 
 # --- Unix ------------------------------------------------------------------
+
+ifeq ($(OS),unix)
 
 cc := gcc
 INCLUDES := -I/usr/include/lua5.2
@@ -205,6 +224,7 @@
 	-D_XOPEN_SOURCE_EXTENDED \
 	-D_XOPEN_SOURCE \
 	-D_GNU_SOURCE \
+	-DARCH=\"unix\" \
 	-I/usr/include/ncursesw
 	
 ldflags := \
@@ -245,8 +265,12 @@
 bin/wordgrinder.1: wordgrinder.man
 	@echo MANPAGE
 	$(hide)sed -e 's/@@@DATE@@@/$(DATE)/g; s/@@@VERSION@@@/$(VERSION)/g' $< > $@
+
+endif
 	
 # --- Windows ---------------------------------------------------------------
+
+ifeq ($(OS),windows)
 
 cc := $(WINCC)
 
@@ -255,11 +279,13 @@
 	-DBUILTIN_LFS \
 	-DWIN32 \
 	-DWINVER=0x0501 \
+	-DARCH=\"windows\" \
 	-Dmain=appMain \
 	-mwindows
-	
+
 ldflags := \
 	-static \
+	-lcomctl32 \
 	-llua \
 	-lz
 
@@ -286,7 +312,9 @@
 $(eval $(build-wordgrinder-windows))
 $(eval $(build-wordgrinder))
 
-src/c/arch/win32/wordgrinder.rc: src/c/arch/win32/icon.ico
+src/c/arch/win32/wordgrinder.rc: \
+	src/c/arch/win32/icon.ico \
+	src/c/arch/win32/manifest.xml
 
 
 $(WININSTALLER): extras/windows-installer.nsi bin/wordgrinder.exe
@@ -298,6 +326,9 @@
 	@echo CLEAN $(WININSTALLER)
 	@rm -f $(WININSTALLER)
 	
+endif
+
 # --- Final setup -----------------------------------------------------------
 
 -include $(DEPENDS)
+

## wordgrinder 0.6

=== Makefile ===
--- 
+++ 
@@ -3,6 +3,8 @@
 # file in this distribution for the full text.
 
 hide = @
+
+.DELETE_ON_ERROR:
 
 PREFIX = $(HOME)
 CC = gcc
@@ -10,15 +12,55 @@
 WINDRES = windres.exe
 MAKENSIS = makensis
 
+USE_LUAJIT = n
+
 ifneq ($(findstring Windows,$(OS)),)
-OS = windows
+	OS = windows
+	TESTER = bin/wordgrinder-debug.exe
+all: windows
+else ifneq ($(Apple_PubSub_Socket_Render),)
+	BREWPREFIX := $(shell brew --prefix 2>/dev/null || echo)
+
+	LIBROOT := $(BREWPREFIX)/lib $(BREWPREFIX)/opt/ncurses/lib
+	INCROOT := $(BREWPREFIX)
+	LUA_INCLUDE := $(BREWPREFIX)/include
+	NCURSES_INCLUDE := /usr/include
+	NCURSES_LIB := -L/usr/lib -lncurses
+	LUA_LIB := -llua.5.2
+
+	OS = unix
+	TESTER = bin/wordgrinder-debug
+all: unix
 else
-OS = unix
+	LIBROOT := /usr/lib
+	INCROOT := /usr
+	ifeq ($(USE_LUAJIT),y)
+		LUA_INCLUDE := $(INCROOT)/include/luajit-2.0
+		LUA_LIB := -lluajit-5.1
+		# The ImmutabliseArray() code, used by the debug version of
+		# WordGrinder to ensure we don't modify stuff we shouldn't,
+		# uses new 5.2 metamethods and doesn't work on LuaJIT.
+		TESTER = bin/wordgrinder
+	else
+		LUA_INCLUDE := $(INCROOT)/include/lua5.2
+		LUA_LIB := -llua5.2
+		TESTER = bin/wordgrinder-debug
+	endif
+
+	NCURSES_CFLAGS := $(shell pkg-config ncursesw --cflags)
+	NCURSES_LIB := $(shell pkg-config ncursesw --libs)
+	X11_CFLAGS := $(shell pkg-config freetype2 --cflags) -I/usr/include/X11
+	X11_LIB := -lX11 -lXft $(shell pkg-config freetype2 --libs) 
+
+	OS = unix
+all: unix x11unix
 endif
 
-VERSION := 0.5.1
-FILEFORMAT := 4
+VERSION := 0.6.0
+FILEFORMAT := 6
 DATE := $(shell date +'%-d %B %Y')
+
+OBJ = .obj/lj_$(USE_LUAJIT)
 
 override CFLAGS += \
 	-DVERSION='"$(VERSION)"' \
@@ -28,24 +70,30 @@
 	-Isrc/c/minizip \
 	-Wall \
 	-ffunction-sections \
+	-Werror=implicit-function-declaration \
 	-fdata-sections \
 	--std=gnu99
 
 override LDFLAGS += \
 
 WININSTALLER := bin/WordGrinder\ $(VERSION)\ setup.exe
-
-all: unix
 
 unix: \
 	bin/wordgrinder \
 	bin/wordgrinder-debug \
+	tests \
 	bin/wordgrinder-static
-.PHONY: unix
+
+x11unix: \
+	bin/xwordgrinder \
+	bin/xwordgrinder-debug \
+	bin/xwordgrinder-static
+.PHONY: unix x11unix
 	
 windows: \
 	bin/wordgrinder.exe \
 	bin/wordgrinder-debug.exe \
+	tests \
 	$(WININSTALLER)
 .PHONY: windows
 
@@ -54,18 +102,24 @@
 
 install: bin/wordgrinder bin/wordgrinder.1
 	@echo INSTALL
-	$(hide)install -D -m 755 bin/wordgrinder   $(PREFIX)/bin/wordgrinder
-	$(hide)install -D -m 644 bin/wordgrinder.1 $(PREFIX)/share/man/man1/wordgrinder.1
-	$(hide)install -D -m 644 README.wg         $(PREFIX)/share/doc/wordgrinder/README.wg
+	$(hide)install -d                       $(PREFIX)/bin
+	$(hide)install -m 755 bin/wordgrinder   $(PREFIX)/bin/wordgrinder
+	$(hide)install -d                       $(PREFIX)/share/man/man1
+	$(hide)install -m 644 bin/wordgrinder.1 $(PREFIX)/share/man/man1/wordgrinder.1
+	$(hide)install -d                       $(PREFIX)/share/doc/wordgrinder
+	$(hide)install -m 644 README.wg         $(PREFIX)/share/doc/wordgrinder/README.wg
 	
 # --- Builds the script blob ------------------------------------------------
 
+# Each script is loaded in this order, which is important.
 LUASCRIPTS := \
 	src/lua/_prologue.lua \
+	src/lua/events.lua \
+	src/lua/main.lua \
 	src/lua/xml.lua \
 	src/lua/utils.lua \
-	src/lua/events.lua \
 	src/lua/redraw.lua \
+	src/lua/settings.lua \
 	src/lua/document.lua \
 	src/lua/forms.lua \
 	src/lua/ui.lua \
@@ -73,12 +127,14 @@
 	src/lua/html.lua \
 	src/lua/margin.lua \
 	src/lua/fileio.lua \
+	src/lua/xpattern.lua \
 	src/lua/export.lua \
 	src/lua/export/text.lua \
 	src/lua/export/html.lua \
 	src/lua/export/latex.lua \
 	src/lua/export/troff.lua \
 	src/lua/export/opendocument.lua \
+	src/lua/export/markdown.lua \
 	src/lua/import.lua \
 	src/lua/import/html.lua \
 	src/lua/import/text.lua \
@@ -88,20 +144,27 @@
 	src/lua/addons/autosave.lua \
 	src/lua/addons/docsetman.lua \
 	src/lua/addons/scrapbook.lua \
-	src/lua/addons/pagecount.lua \
-	src/lua/addons/widescreen.lua \
+	src/lua/addons/statusbar_charstyle.lua \
+	src/lua/addons/statusbar_pagecount.lua \
+	src/lua/addons/statusbar_position.lua \
+	src/lua/addons/statusbar_wordcount.lua \
+	src/lua/addons/debug.lua \
+	src/lua/addons/look-and-feel.lua \
+	src/lua/addons/keymapoverride.lua \
+	src/lua/addons/smartquotes.lua \
+	src/lua/addons/undo.lua \
+	src/lua/addons/spillchocker.lua \
 	src/lua/menu.lua \
 	src/lua/cli.lua \
-	src/lua/main.lua
-
-.obj/luascripts.c: $(LUASCRIPTS)
+
+$(OBJ)/luascripts.c: $(LUASCRIPTS)
 	@echo SCRIPTS
-	@mkdir -p .obj
-	@lua tools/multibin2c.lua script_table $^ > $@
+	@mkdir -p $(OBJ)
+	$(hide)lua tools/multibin2c.lua script_table $^ > $@
 	
 clean::
-	@echo CLEAN .obj/luascripts.c
-	@rm -f .obj/luascripts.c
+	@echo CLEAN $(OBJ)/luascripts.c
+	@rm -f $(OBJ)/luascripts.c
 	
 # --- Builds a single C file ------------------------------------------------
 
@@ -161,7 +224,7 @@
 $(call cfile, src/c/lua.c)
 $(call cfile, src/c/word.c)
 $(call cfile, src/c/screen.c)
-$(call cfile, .obj/luascripts.c)
+$(call cfile, $(OBJ)/luascripts.c)
 
 endef
 
@@ -196,6 +259,15 @@
 define build-wordgrinder-ncurses
 
 $(call cfile, src/c/arch/unix/cursesw/dpy.c)
+
+endef
+
+# --- Builds the X11 front end ----------------------------------------------
+
+define build-wordgrinder-x11
+
+$(call cfile, src/c/arch/unix/x11/x11.c)
+$(call cfile, src/c/arch/unix/x11/glyphcache.c)
 
 endef
 
@@ -218,42 +290,46 @@
 ifeq ($(OS),unix)
 
 cc := gcc
-INCLUDES := -I/usr/include/lua5.2
+INCLUDES := -I$(LUA_INCLUDE)
 
 UNIXCFLAGS := \
 	-D_XOPEN_SOURCE_EXTENDED \
 	-D_XOPEN_SOURCE \
 	-D_GNU_SOURCE \
-	-DARCH=\"unix\" \
-	-I/usr/include/ncursesw
-	
-ldflags := \
-	-lncursesw \
-	-llua5.2 \
+	-DARCH=\"unix\"
+	
+UNIXLDFLAGS := \
+	$(addprefix -L,$(LIBROOT)) \
+	$(LUA_LIB) \
 	-lz
 
-cflags := $(UNIXCFLAGS) -Os -DNDEBUG
-objdir := .obj/release
+cflags := $(UNIXCFLAGS) $(NCURSES_CFLAGS) -Os -DNDEBUG
+objdir := $(OBJ)/release
 exe := bin/wordgrinder
 objs :=
+ldflags := $(UNIXLDFLAGS) $(NCURSES_LIB) -DBUILTIN_LFS
 $(eval $(build-wordgrinder-core))
 $(eval $(build-wordgrinder-ncurses))
 $(eval $(build-wordgrinder-minizip))
-$(eval $(build-wordgrinder))
-
-cflags := $(UNIXCFLAGS) -g
-objdir := .obj/debug
+$(eval $(build-wordgrinder-lfs))
+$(eval $(build-wordgrinder))
+
+cflags := $(UNIXCFLAGS) $(NCURSES_CFLAGS) -g -DBUILTIN_LFS
+objdir := $(OBJ)/debug
 exe := bin/wordgrinder-debug
 objs :=
+ldflags := $(UNIXLDFLAGS) $(NCURSES_LIB)
 $(eval $(build-wordgrinder-core))
 $(eval $(build-wordgrinder-ncurses))
 $(eval $(build-wordgrinder-minizip))
-$(eval $(build-wordgrinder))
-
-cflags := $(UNIXCFLAGS) -g -DEMULATED_WCWIDTH -DBUILTIN_LFS
-objdir := .obj/debug-static
+$(eval $(build-wordgrinder-lfs))
+$(eval $(build-wordgrinder))
+
+cflags := $(UNIXCFLAGS) $(NCURSES_CFLAGS) -g -DEMULATED_WCWIDTH -DBUILTIN_LFS
+objdir := $(OBJ)/debug-static
 exe := bin/wordgrinder-static
 objs :=
+ldflags := $(UNIXLDFLAGS) $(NCURSES_LIB)
 $(eval $(build-wordgrinder-core))
 $(eval $(build-wordgrinder-ncurses))
 $(eval $(build-wordgrinder-minizip))
@@ -261,6 +337,39 @@
 $(eval $(build-wordgrinder-emu))
 $(eval $(build-wordgrinder))
 
+cflags := $(UNIXCFLAGS) $(X11_CFLAGS) -Os -DNDEBUG -DBUILTIN_LFS
+objdir := $(OBJ)/release-x11
+exe := bin/xwordgrinder
+objs :=
+ldflags := $(UNIXLDFLAGS) $(X11_LIB)
+$(eval $(build-wordgrinder-core))
+$(eval $(build-wordgrinder-x11))
+$(eval $(build-wordgrinder-minizip))
+$(eval $(build-wordgrinder-lfs))
+$(eval $(build-wordgrinder))
+
+cflags := $(UNIXCFLAGS) $(X11_CFLAGS) -g -DBUILTIN_LFS
+objdir := $(OBJ)/debug-x11
+exe := bin/xwordgrinder-debug
+objs :=
+ldflags := $(UNIXLDFLAGS) $(X11_LIB)
+$(eval $(build-wordgrinder-core))
+$(eval $(build-wordgrinder-x11))
+$(eval $(build-wordgrinder-minizip))
+$(eval $(build-wordgrinder-lfs))
+$(eval $(build-wordgrinder))
+
+cflags := $(UNIXCFLAGS) $(X11_CFLAGS) -g -DEMULATED_WCWIDTH -DBUILTIN_LFS
+objdir := $(OBJ)/debug-static-x11
+exe := bin/xwordgrinder-static
+objs :=
+ldflags := $(UNIXLDFLAGS) $(X11_LIB)
+$(eval $(build-wordgrinder-core))
+$(eval $(build-wordgrinder-x11))
+$(eval $(build-wordgrinder-minizip))
+$(eval $(build-wordgrinder-lfs))
+$(eval $(build-wordgrinder-emu))
+$(eval $(build-wordgrinder))
 
 bin/wordgrinder.1: wordgrinder.man
 	@echo MANPAGE
@@ -290,7 +399,7 @@
 	-lz
 
 cflags := $(WINDOWSCFLAGS) -Os -DNDEBUG
-objdir := .obj/win32-release
+objdir := $(OBJ)/win32-release
 exe := bin/wordgrinder.exe
 objs :=
 $(eval $(build-wordgrinder-core))
@@ -302,7 +411,7 @@
 
 
 cflags := $(WINDOWSCFLAGS) -g
-objdir := .obj/win32-debug
+objdir := $(OBJ)/win32-debug
 exe := bin/wordgrinder-debug.exe
 objs :=
 $(eval $(build-wordgrinder-core))
@@ -328,7 +437,37 @@
 	
 endif
 
-# --- Final setup -----------------------------------------------------------
-
--include $(DEPENDS)
-
+# --- Tests -----------------------------------------------------------------
+
+define run-test
+
+$(OBJ)/$(strip $1).passed: $(TESTER) $1
+	@echo TEST $1
+	@mkdir -p $$(dir $$@)
+	@rm -f $$@
+	$(hide) $(TESTER) --lua $1
+	@touch $$@
+
+tests: $(OBJ)/$(strip $1).passed
+
+endef
+
+$(eval $(call run-test, tests/apply-markup.lua))
+$(eval $(call run-test, tests/change-paragraph-style.lua))
+$(eval $(call run-test, tests/clipboard.lua))
+$(eval $(call run-test, tests/delete-selection.lua))
+$(eval $(call run-test, tests/export-to-text.lua))
+$(eval $(call run-test, tests/find-and-replace.lua))
+$(eval $(call run-test, tests/get-style-from-word.lua))
+$(eval $(call run-test, tests/immutable-paragraphs.lua))
+$(eval $(call run-test, tests/insert-space-with-style-hint.lua))
+$(eval $(call run-test, tests/line-down-into-style.lua))
+$(eval $(call run-test, tests/line-up.lua))
+$(eval $(call run-test, tests/line-wrapping.lua))
+$(eval $(call run-test, tests/load-0.1.lua))
+$(eval $(call run-test, tests/load-0.2.lua))
+$(eval $(call run-test, tests/load-0.3.3.lua))
+$(eval $(call run-test, tests/load-0.4.1.lua))
+$(eval $(call run-test, tests/load-0.5.3.lua))
+$(eval $(call run-test, tests/load-failed.lua))
+$(eval $(call run-test, tests/move-while-selected.lua))

=== debian/changelog ===
wordgrinder (0.6-3build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 09:47:29 +0000

wordgrinder (0.6-3) unstable; urgency=medium

  * Fix missing dependency (Closes: #801909)

 -- David Given <dg@cowlark.com>  Sat, 17 Oct 2015 12:12:04 +0200

wordgrinder (0.6-2) unstable; urgency=medium

  * Fix debian/rules bug that was causing FTBFS on the build servers
    (Closes: #801697)
  * Update urgency to 'medium' (the new standard)

 -- David Given <dg@cowlark.com>  Tue, 13 Oct 2015 21:29:22 +0200

wordgrinder (0.6-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Thu, 24 Sep 2015 23:47:32 +0200

wordgrinder (0.5.1-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Fri, 13 Dec 2013 01:23:54 +0000

wordgrinder (0.4.1-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Sun, 14 Apr 2013 21:12:31 +0000

wordgrinder (0.3.3-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Mon, 14 Dec 2009 21:42:12 +0000

wordgrinder (0.3.2-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Thu, 19 Feb 2009 23:54:29 +0000

wordgrinder (0.3.1-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Mon, 15 Sep 2008 23:14:39 +0100

wordgrinder (0.2-2) unstable; urgency=low

  * Fixed incorrect Depends: line (Closes: #464002)
  * Backported fix from upstream about not being able to rebind keys 
    that had a default keybinding (Closes: #464007)

 -- David Given <dg@cowlark.com>  Mon, 04 Feb 2008 20:45:50 +0000

wordgrinder (0.2-1) unstable; urgency=low

  * Initial release (Closes: #461515)

 -- David Given <dg@cowlark.com>  Sat, 19 Jan 2008 10:13:06 +0000

=== debian/control ===
Source: wordgrinder
Section: editors
Priority: optional
Maintainer: David Given <dg@cowlark.com>
Build-Depends: debhelper (>= 9.0.0), libncursesw5-dev, liblua5.2-dev, lua-filesystem-dev, lua5.2, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev
Standards-Version: 3.9.6
Homepage: http://cowlark.com/wordgrinder

Package: wordgrinder
Depends: wordgrinder-ncurses, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: simple word processor for writing first drafts
 This is a transitional dummy package. It can safely be removed.

Package: wordgrinder-ncurses
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, wordgrinder-doc, lua-filesystem
Replaces: wordgrinder (<< 0.6-1)
Breaks: wordgrinder (<< 0.6-1)
Description: simple word processor for writing first drafts (terminal version)
 WordGrinder is a simple, Unicode-aware word processor. It supports basic
 paragraph styles, character styles, just enough screen markup to be useful,
 and is driven via an easy to use menu interface.
 .
 This version runs in a terminal.

Package: wordgrinder-x11
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, wordgrinder-doc, lua-filesystem
Description: simple word processor for writing first drafts (X11 version)
 WordGrinder is a simple, Unicode-aware word processor. It supports basic
 paragraph styles, character styles, just enough screen markup to be useful,
 and is driven via an easy to use menu interface.
 .
 This version runs on X.

Package: wordgrinder-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Description: simple word processor for writing first drafts (documentation)
 WordGrinder is a simple, Unicode-aware word processor. It supports basic
 paragraph styles, character styles, just enough screen markup to be useful,
 and is driven via an easy to use menu interface.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Use hardening build flags.
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_testdir
	make bin/wordgrinder bin/xwordgrinder \
		CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)"
	
.PHONY: override_dh_auto_test
override_dh_auto_test:
	dh_testdir
	make tests \
		CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)"

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	rm -rf .obj bin

.PHONY: override_dh_auto_install
override_dh_auto_install:

.PHONY: override_dh_install
override_dh_install:
	make install PREFIX=debian/tmp/usr
	dh_install

%:
	dh $@

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
  http://github.com/davidgiven/wordgrinder/releases .*/(\d\S*)\.tar\.gz

## wordgrinder 0.7.1

=== Makefile ===
# ===========================================================================
#                          CONFIGURATION OPTIONS
# ===========================================================================

# It should be mostly safe to leave these options at the default.

PREFIX ?= $(HOME)
BINDIR ?= $(PREFIX)/bin
DOCDIR ?= $(PREFIX)/share/doc
MANDIR ?= $(PREFIX)/share/man
DESTDIR ?=

# Where do the temporary files go?
OBJDIR = /tmp/wg-build

# The compiler used for the native build (curses, X11)
CC ?= cc

# Global CFLAGS and LDFLAGS.
CFLAGS ?=
LDFLAGS ?=

# Used for the Windows build (either cross or native)
WINCC ?= i686-w64-mingw32-gcc
WINDRES ?= i686-w64-mingw32-windres
MAKENSIS ?= makensis
ifneq ($(strip $(shell type $(MAKENSIS) >/dev/null 2>&1; echo $$?)),0)
	# If makensis isn't on the path, chances are we're on Cygwin doing a
	# Windows build --- so look in the default installation directory.
	MAKENSIS := /cygdrive/c/Program\ Files\ \(x86\)/NSIS/makensis.exe
endif

# Application version and file format.
VERSION := 0.7.1
FILEFORMAT := 7
DATE ?= $(shell date +'%-d %B %Y')

# Which Lua do you want to use?
#
# Use 'builtin' if you want to use the built-in Lua 5.1. If
# you want to dynamically link to your system's Lua, or to Luajit,
# use a pkg-config name instead (e.g. lua-5.1, lua-5.2, luajit).
# WordGrinder works with 5.1, 5.2, 5.3, and LuaJit.
#
# Alternatively, use a flag specifier string like this:
# --cflags={-I/usr/include/thingylua} --libs={-L/usr/lib/thingylua -lthingylua}
LUA_PACKAGE ?= builtin

# Hack to try and detect the presence of the Xft library (it's not in
# pkg-config).
ifneq ($(wildcard /usr/include/X11/Xft/Xft.h),)
	XFT_PACKAGE ?= --libs={-lX11 -lXft}
else
	XFT_PACKAGE ?= none
endif

# Hack to try and detect OSX's non-pkg-config compliant ncurses.
ifneq ($(filter Darwin%,$(shell uname)),)
	CURSES_PACKAGE ?= --cflags={-I/usr/include} --libs={-L/usr/lib -lncurses}
else
	CURSES_PACKAGE ?= ncursesw
endif

# By default, WordGrinder uses the builtin versions of these libraries.
# However, they're overridable --- this is mainly of use if you're a
# package maintainer and want to dynamically link to your platform's
# version.
#
# Important note: the pkg-config files for Lua packages are typically
# wrong, as they'll try to link in the wrong Lua library. You'll
# probably have to use a manual flag specifier string. Also, setting
# these only makes sense with 'make all' --- don't use this with
# 'make dev' (but you probably won't be doing this anyway).

LUAFILESYSTEM_PACKAGE ?= builtin
LUABITOP_PACKAGE ?= builtin
MINIZIP_PACKAGE ?= builtin
UTHASH_PACKAGE ?= builtin

# ===========================================================================
#                       END OF CONFIGURATION OPTIONS
# ===========================================================================
#
# If you need to edit anything below here, please let me know so I can add
# a proper configuration option.

hide = @

LUA_INTERPRETER = $(OBJDIR)/lua

NINJABUILD = \
	$(hide) ninja -f $(OBJDIR)/build.ninja $(NINJAFLAGS)

# Builds and tests the Unix release versions only.
.PHONY: all
all: $(OBJDIR)/build.ninja
	$(NINJABUILD) all

# Builds, tests and installs the Unix release versions only.
.PHONY: install
install: $(OBJDIR)/build.ninja
	$(NINJABUILD) install

# Builds and tests everything that's buildable on your machine.
.PHONY: dev
dev: $(OBJDIR)/build.ninja
	$(NINJABUILD) dev

# Builds Windows (but doesn't test it because that's hard).
.PHONY: windows
windows: $(OBJDIR)/build.ninja
	$(NINJABUILD) bin/WordGrinder-$(VERSION)-setup.exe

$(OBJDIR)/build.ninja:: $(LUA_INTERPRETER) build.lua Makefile
	@mkdir -p $(dir $@)
	$(hide) $(LUA_INTERPRETER) build.lua \
		BINDIR="$(BINDIR)" \
		BUILDFILE="$@" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		CURSES_PACKAGE="$(CURSES_PACKAGE)" \
		DATE="$(DATE)" \
		DESTDIR="$(DESTDIR)" \
		DOCDIR="$(DOCDIR)" \
		FILEFORMAT="$(FILEFORMAT)" \
		LDFLAGS="$(LDFLAGS)" \
		LUABITOP_PACKAGE="$(LUABITOP_PACKAGE)" \
		LUAFILESYSTEM_PACKAGE="$(LUAFILESYSTEM_PACKAGE)" \
		LUA_INTERPRETER="$(LUA_INTERPRETER)" \
		LUA_PACKAGE="$(LUA_PACKAGE)" \
		MAKENSIS="$(MAKENSIS)" \
		MANDIR="$(MANDIR)" \
		MINIZIP_PACKAGE="$(MINIZIP_PACKAGE)" \
		OBJDIR="$(OBJDIR)" \
		UTHASH_PACKAGE="$(UTHASH_PACKAGE)" \
		VERSION="$(VERSION)" \
		WINCC="$(WINCC)" \
		WINDRES="$(WINDRES)" \
		XFT_PACKAGE="$(XFT_PACKAGE)" \

clean:
	@echo CLEAN
	@rm -rf $(OBJDIR)

ifeq ($(LUA_INTERPRETER),$(OBJDIR)/lua)
$(LUA_INTERPRETER): src/c/emu/lua-5.1.5/*.[ch]
	@echo Bootstrapping build
	@mkdir -p $(dir $@)
	@$(CC) -o $(LUA_INTERPRETER) -O src/c/emu/lua-5.1.5/*.c -lm -DLUA_USE_MKSTEMP
endif

=== debian/changelog ===
wordgrinder (0.7.1-1) unstable; urgency=medium

  * New upstream release

 -- David Given <dg@cowlark.com>  Thu, 2 Nov 2017 18:53:00 +0000

wordgrinder (0.6-4) unstable; urgency=medium

  * Fix reproducible build (Closes: #831742)
  * Bump standards version.

 -- David Given <dg@cowlark.com>  Mon, 30 Jan 2017 21:09:34 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: editors
 Priority: optional
 Maintainer: David Given <dg@cowlark.com>
-Build-Depends: debhelper (>= 9.0.0), libncursesw5-dev, liblua5.2-dev, lua-filesystem-dev, lua5.2, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9.0.0), ninja-build, libncursesw5-dev, liblua5.3-dev, lua-filesystem-dev, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev, libminizip-dev, uthash-dev, lua5.1
+Standards-Version: 3.9.8
 Homepage: http://cowlark.com/wordgrinder
 
 Package: wordgrinder

## wordgrinder 0.7.2

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 endif
 
 # Application version and file format.
-VERSION := 0.7.1
+VERSION := 0.7.2
 FILEFORMAT := 7
 DATE ?= $(shell date +'%-d %B %Y')
 
@@ -49,13 +49,20 @@
 # Hack to try and detect the presence of the Xft library (it's not in
 # pkg-config).
 ifneq ($(wildcard /usr/include/X11/Xft/Xft.h),)
-	XFT_PACKAGE ?= --libs={-lX11 -lXft}
+	XFT_PACKAGE ?= \
+		--cflags={-I/usr/include/X11} --libs={-lX11 -lXft}
+else ifneq ($(wildcard /usr/X11R6/include/X11/Xft/Xft.h),)
+	XFT_PACKAGE ?= \
+		--cflags={-I/usr/X11R6/include -I/usr/X11R6/include/X11} \
+		--libs={-L/usr/X11R6/lib -lX11 -lXft}
 else
 	XFT_PACKAGE ?= none
 endif
 
 # Hack to try and detect OSX's non-pkg-config compliant ncurses.
 ifneq ($(filter Darwin%,$(shell uname)),)
+	CURSES_PACKAGE ?= --cflags={-I/usr/include} --libs={-L/usr/lib -lncurses}
+else ifneq ($(filter OpenBSD,$(shell uname)),)
 	CURSES_PACKAGE ?= --cflags={-I/usr/include} --libs={-L/usr/lib -lncurses}
 else
 	CURSES_PACKAGE ?= ncursesw
@@ -76,6 +83,10 @@
 LUABITOP_PACKAGE ?= builtin
 MINIZIP_PACKAGE ?= builtin
 UTHASH_PACKAGE ?= builtin
+
+# Do you want your binaries stripped on installation?
+
+WANT_STRIPPED_BINARIES ?= yes
 
 # ===========================================================================
 #                       END OF CONFIGURATION OPTIONS
@@ -100,6 +111,11 @@
 .PHONY: install
 install: $(OBJDIR)/build.ninja
 	$(NINJABUILD) install
+
+# Builds and installs the Unix release versions only, without testing.
+.PHONY: install-notests
+install-notests: $(OBJDIR)/build.ninja
+	$(NINJABUILD) install-notests
 
 # Builds and tests everything that's buildable on your machine.
 .PHONY: dev
@@ -134,13 +150,14 @@
 		OBJDIR="$(OBJDIR)" \
 		UTHASH_PACKAGE="$(UTHASH_PACKAGE)" \
 		VERSION="$(VERSION)" \
+		WANT_STRIPPED_BINARIES="$(WANT_STRIPPED_BINARIES)" \
 		WINCC="$(WINCC)" \
 		WINDRES="$(WINDRES)" \
 		XFT_PACKAGE="$(XFT_PACKAGE)" \
 
 clean:
 	@echo CLEAN
-	@rm -rf $(OBJDIR)
+	@rm -rf $(OBJDIR) bin
 
 ifeq ($(LUA_INTERPRETER),$(OBJDIR)/lua)
 $(LUA_INTERPRETER): src/c/emu/lua-5.1.5/*.[ch]

=== debian/changelog ===
wordgrinder (0.7.2-1) unstable; urgency=medium

  * New upstream release

 -- David Given <dg@cowlark.com>  Thu, 29 Nov 2018 21:18:05 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
 Package: wordgrinder
 Depends: wordgrinder-ncurses, ${misc:Depends}
 Architecture: all
-Priority: extra
 Section: oldlibs
 Description: simple word processor for writing first drafts
  This is a transitional dummy package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Exported to the package makefile.
PACKAGE_VARS = \
	PREFIX=/usr \
	DESTDIR=debian/tmp \
	OBJDIR=.obj \
	LUA_PACKAGE=lua-5.3 \
	LUABITOP_PACKAGE="--cflags={} --libs={}" \
	LUAFILESYSTEM_PACKAGE=lua5.3-filesystem \
	MINIZIP_PACKAGE=minizip \
	UTHASH_PACKAGE="--cflags={} --libs={}" \
	LUA_INTERPRETER=/usr/bin/lua5.1 \
	CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
	LDFLAGS="$(LDFLAGS)" \

# Use hardening build flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_testdir
	make all $(PACKAGE_VARS)
	
.PHONY: override_dh_auto_test
override_dh_auto_test:
	dh_testdir
	make tests $(PACKAGE_VARS)

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	make clean $(PACKAGE_VARS)

.PHONY: override_dh_auto_install
override_dh_auto_install:

.PHONY: override_dh_install
override_dh_install:
	make install $(PACKAGE_VARS)
	dh_install

%:
	dh $@

## wordgrinder 0.8

=== Makefile ===
--- 
+++ 
@@ -6,15 +6,27 @@
 
 PREFIX ?= $(HOME)
 BINDIR ?= $(PREFIX)/bin
-DOCDIR ?= $(PREFIX)/share/doc
-MANDIR ?= $(PREFIX)/share/man
+SHAREDIR ?= $(PREFIX)/share
+DOCDIR ?= $(SHAREDIR)/doc
+MANDIR ?= $(SHAREDIR)/man
 DESTDIR ?=
 
 # Where do the temporary files go?
-OBJDIR = /tmp/wg-build
+OBJDIR = .obj
 
 # The compiler used for the native build (curses, X11)
 CC ?= cc
+
+# Which ninja do you want to use?
+ifeq ($(strip $(shell type ninja >/dev/null; echo $$?)),0)
+	NINJA ?= ninja
+else
+	ifeq ($(strip $(shell type ninja-build >/dev/null; echo $$?)),0)
+		NINJA ?= ninja-build
+    else
+        $(error No ninja found)
+    endif
+endif
 
 # Global CFLAGS and LDFLAGS.
 CFLAGS ?=
@@ -31,9 +43,14 @@
 endif
 
 # Application version and file format.
-VERSION := 0.7.2
-FILEFORMAT := 7
-DATE ?= $(shell date +'%-d %B %Y')
+VERSION := 0.8
+FILEFORMAT := 8
+
+ifdef SOURCE_DATE_EPOCH
+       DATE := $(shell LC_ALL date --utc --date="@$(SOURCE_DATE_EPOCH)" +'%-d %B %Y')
+else
+       DATE := $(shell date +'%-d %B %Y')
+endif
 
 # Which Lua do you want to use?
 #
@@ -79,7 +96,7 @@
 # these only makes sense with 'make all' --- don't use this with
 # 'make dev' (but you probably won't be doing this anyway).
 
-LUAFILESYSTEM_PACKAGE ?= builtin
+LPEG_PACKAGE ?= builtin
 LUABITOP_PACKAGE ?= builtin
 MINIZIP_PACKAGE ?= builtin
 UTHASH_PACKAGE ?= builtin
@@ -100,7 +117,7 @@
 LUA_INTERPRETER = $(OBJDIR)/lua
 
 NINJABUILD = \
-	$(hide) ninja -f $(OBJDIR)/build.ninja $(NINJAFLAGS)
+	$(hide) $(NINJA) -f $(OBJDIR)/build.ninja $(NINJAFLAGS)
 
 # Builds and tests the Unix release versions only.
 .PHONY: all
@@ -117,21 +134,31 @@
 install-notests: $(OBJDIR)/build.ninja
 	$(NINJABUILD) install-notests
 
-# Builds and tests everything that's buildable on your machine.
+# Builds and tests everything that's buildable on your machine. Don't use this
+# unless you know what you're doing (it's pretty brittle given non-standard
+# build flags).
 .PHONY: dev
 dev: $(OBJDIR)/build.ninja
 	$(NINJABUILD) dev
 
-# Builds Windows (but doesn't test it because that's hard).
+# Builds Windows, possibly via cross-compilation (but doesn't test it because
+# we can only do that on actual Windows).
 .PHONY: windows
 windows: $(OBJDIR)/build.ninja
-	$(NINJABUILD) bin/WordGrinder-$(VERSION)-setup.exe
+	$(NINJABUILD) bin/WordGrinder-$(VERSION)-setup.exe 
+
+# Run the Windows tests
+.PHONY: wintests
+wintests: $(OBJDIR)/build.ninja
+	$(NINJABUILD) wintests
+
+.DELETE_ON_ERROR:
 
 $(OBJDIR)/build.ninja:: $(LUA_INTERPRETER) build.lua Makefile
 	@mkdir -p $(dir $@)
 	$(hide) $(LUA_INTERPRETER) build.lua \
 		BINDIR="$(BINDIR)" \
-		BUILDFILE="$@" \
+		BUILDFILE="$@.tmp" \
 		CC="$(CC)" \
 		CFLAGS="$(CFLAGS)" \
 		CURSES_PACKAGE="$(CURSES_PACKAGE)" \
@@ -141,19 +168,21 @@
 		FILEFORMAT="$(FILEFORMAT)" \
 		LDFLAGS="$(LDFLAGS)" \
 		LUABITOP_PACKAGE="$(LUABITOP_PACKAGE)" \
-		LUAFILESYSTEM_PACKAGE="$(LUAFILESYSTEM_PACKAGE)" \
+		LPEG_PACKAGE="$(LPEG_PACKAGE)" \
 		LUA_INTERPRETER="$(LUA_INTERPRETER)" \
 		LUA_PACKAGE="$(LUA_PACKAGE)" \
 		MAKENSIS="$(MAKENSIS)" \
 		MANDIR="$(MANDIR)" \
 		MINIZIP_PACKAGE="$(MINIZIP_PACKAGE)" \
 		OBJDIR="$(OBJDIR)" \
+		SHAREDIR="$(SHAREDIR)" \
 		UTHASH_PACKAGE="$(UTHASH_PACKAGE)" \
 		VERSION="$(VERSION)" \
 		WANT_STRIPPED_BINARIES="$(WANT_STRIPPED_BINARIES)" \
 		WINCC="$(WINCC)" \
 		WINDRES="$(WINDRES)" \
-		XFT_PACKAGE="$(XFT_PACKAGE)" \
+		XFT_PACKAGE="$(XFT_PACKAGE)"
+	$(hide) mv $@.tmp $@
 
 clean:
 	@echo CLEAN
@@ -163,6 +192,52 @@
 $(LUA_INTERPRETER): src/c/emu/lua-5.1.5/*.[ch]
 	@echo Bootstrapping build
 	@mkdir -p $(dir $@)
-	@$(CC) -o $(LUA_INTERPRETER) -O src/c/emu/lua-5.1.5/*.c -lm -DLUA_USE_MKSTEMP
-endif
-
+	@$(CC) -o $(LUA_INTERPRETER) -O src/c/emu/lua-5.1.5/*.c src/c/emu/tmpnam.c -lm -DLUA_USE_EMU_TMPNAM
+endif
+
+.PHONY: distr
+distr: wordgrinder-$(VERSION).tar.xz
+
+.PHONY: debian-distr
+debian-distr: wordgrinder-$(VERSION)-minimal-dependencies-for-debian.tar.xz
+
+.PHONY: wordgrinder-$(VERSION).tar.xz
+wordgrinder-$(VERSION).tar.xz:
+	tar cvaf $@ \
+		--transform "s,^,wordgrinder-$(VERSION)/," \
+		extras \
+		licenses \
+		scripts \
+		src \
+		testdocs \
+		tests \
+		tools \
+		build.lua \
+		Makefile \
+		README \
+		README.wg \
+		README.Windows.txt \
+		wordgrinder.man \
+		xwordgrinder.man
+
+.PHONY: wordgrinder-$(VERSION)-minimal-dependencies-for-debian.tar.xz
+wordgrinder-$(VERSION)-minimal-dependencies-for-debian.tar.xz:
+	tar cvaf $@ \
+		--transform "s,^,wordgrinder-$(VERSION)/," \
+		--exclude "*.dictionary" \
+		--exclude "src/c/emu" \
+		extras \
+		licenses \
+		scripts \
+		src \
+		testdocs \
+		tests \
+		tools \
+		build.lua \
+		Makefile \
+		README \
+		README.wg \
+		README.Windows.txt \
+		wordgrinder.man \
+		xwordgrinder.man
+

=== debian/changelog ===
wordgrinder (0.8-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS with new version of ncurses (Closes: #971114)

 -- David Given <dg@cowlark.com>  Fri, 16 Oct 2020 21:22:20 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: editors
 Priority: optional
 Maintainer: David Given <dg@cowlark.com>
-Build-Depends: debhelper (>= 9.0.0), ninja-build, libncursesw5-dev, liblua5.3-dev, lua-filesystem-dev, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev, libminizip-dev, uthash-dev, lua5.1
-Standards-Version: 3.9.8
+Build-Depends: debhelper-compat (= 13), debhelper (>= 13.0.0), ninja-build, libncursesw5-dev, liblua5.3-dev, lua-lpeg-dev, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev, libminizip-dev, uthash-dev, lua5.3, imagemagick
+Standards-Version: 4.5.0
 Homepage: http://cowlark.com/wordgrinder
+Rules-Requires-Root: no
 
 Package: wordgrinder
 Depends: wordgrinder-ncurses, ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -14,12 +14,13 @@
 	OBJDIR=.obj \
 	LUA_PACKAGE=lua-5.3 \
 	LUABITOP_PACKAGE="--cflags={} --libs={}" \
-	LUAFILESYSTEM_PACKAGE=lua5.3-filesystem \
+	LPEG_PACKAGE=lua5.3-lpeg \
 	MINIZIP_PACKAGE=minizip \
 	UTHASH_PACKAGE="--cflags={} --libs={}" \
-	LUA_INTERPRETER=/usr/bin/lua5.1 \
+	LUA_INTERPRETER=/usr/bin/lua5.3 \
 	CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
 	LDFLAGS="$(LDFLAGS)" \
+	WANT_STRIPPED_BINARIES=yes
 
 # Use hardening build flags.
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -49,5 +50,5 @@
 	dh_install
 
 %:
-	dh $@ 
+	dh $@

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/wordgrinder-$1\.tar\.gz/ \
  https://github.com/davidgiven/wordgrinder/releases .*/(\d\S*)\.tar\.gz
